from flask import Flask, url_for, render_template, Blueprint
from flask_login import current_user
from flask_wtf import FlaskForm
from wtforms import StringField, PasswordField
import minibase.theme as theme
from minibase.blueprints.user.models import Users, User_Roles
from sqlalchemy import inspect

main = Blueprint('main', __name__, template_folder='templates')

class LoginForm(FlaskForm):
   username = StringField('username')
   password = StringField('password')


@main.route('/', methods=['GET', 'POST'])
def index():
    titles = User_Roles.__table__.columns.keys()
    items  = User_Roles.query.all()
    item_link = "/user/link/"
    return render_template('/main/index.html', theme=theme, table=items, titles=titles, item_link=item_link)


